#include <stdlib.h>
#include <string.h>
#include <stdio.h>

typedef struct { int k; char N[36]; } T_station;
static T_station *Stn, *Pst;

typedef struct { int d,a,r,t; char *D,*A; } T_train;
static T_train *Trn;

static int nst, ntr;

static int cmpS(const void *A, const void *B) {
T_station *P = (T_station *)A, *Q = (T_station *)B;
return P->k - Q->k;
}

static void readStations() {
int k;
Stn = calloc(nst,sizeof(T_station));
for (k=0,Pst=Stn; k<nst; k++,Pst++)
    scanf("%d %[^\n]",&Pst->k,Pst->N);
qsort(Stn,nst,sizeof(T_station),cmpS);
}

static int cmpT(const void *A, const void *B) {
T_train *P = (T_train *)A, *Q = (T_train *)B;
int d;
if (d=strcmp(P->D,Q->D)) return d;
return strcmp(P->A,Q->A);
}

static void readTrains() {
int k,w;
void *W;
T_train *Ptr;
Trn = calloc(ntr+1,sizeof(T_train));
for (k=0,Ptr=Trn; k<ntr; k++,Ptr++) {
    Ptr->t = 1;
    scanf("%*s %d %d %*s %d %*s",&Ptr->r,&Ptr->d,&Ptr->a);
    Pst = bsearch(&Ptr->d,Stn,nst,sizeof(T_station),cmpS);
    Ptr->D = Pst->N;
    Pst = bsearch(&Ptr->a,Stn,nst,sizeof(T_station),cmpS);
    Ptr->A = Pst->N;
    if (strcmp(Ptr->D,Ptr->A)>0) {
       w = Ptr->d; Ptr->d = Ptr->a; Ptr->a = w;
       Ptr->r = -Ptr->r;
       Ptr->t = -1;
       W = Ptr->D; Ptr->D = Ptr->A; Ptr->A = W;
       }
    }
qsort(Trn,ntr,sizeof(T_train),cmpT);
}

static void inconsistencies() {
T_train *Pa,*Pn;
for (Pa=Pn=Trn; Pn->d; Pn++) {
    if (Pa==Pn) continue;
    if (Pa->d==Pn->d) if (Pa->a==Pn->a) {
       Pa->t += Pn->t;
       Pa->r += Pn->r;
       continue;
       }
    memcpy(++Pa,Pn,sizeof(T_train));
    }
memset(++Pa,0,sizeof(T_train));
for (Pa=Trn; Pa->d; Pa++) {
    if (Pa->t!=0) {
       printf("%d %s - %d %s, number of trains\n",Pa->d,Pa->D,Pa->a,Pa->A);
       continue;
       }
    if (Pa->r!=0) {
       printf("%d %s - %d %s, restrictions\n",Pa->d,Pa->D,Pa->a,Pa->A);
       continue;
       }
    }
}

int main() {
scanf("%d %d",&nst,&ntr);
readStations();
readTrains();
inconsistencies(); 
return 0;
}
