#include <iostream>
#include <climits>
#include <cstdio>

using namespace std;

long long table[30][30][30];
int glasses[30][30][30];

int check(long long n);

long long megold(long long n);

void clearTable(long long n);

int main() {

    long long n;
    long long sum = 0;

    long long e;
    cin >> n;
    sum = 0;

    for(int i = 0; i < n; ++i){
        for(int j = 0; j <= i; ++j){
            for(int k = 0; k <= i; ++k){
                cin >> glasses[i][j][k];
                sum += glasses[i][j][k];
            }
        }
    }

    e = megold(n);

    cout << e << " " << e - sum << "\n";

    return 0;
}



long long megold(long long n){
    long long e = 0;
    long long u = LONG_LONG_MAX;

    while (e != u) {
        long long k = e + (u - e) / 2;

        clearTable(n);
        table[0][0][0] = k;
        int m = check(n);

        if (m) { // megtelt az osszes pohar
            u = k;
        } else {
            e = k + 1;
        }

    }

    return e;
}

void clearTable(long long n) {
    for(long long i = 0; i < n; ++i){
        for(long long j = 0; j < 30; ++j){
            for(long long k = 0; k < 30; ++k){
                table[i][j][k] = 0;
            }
        }
    }
}

int check(long long n){

    for(long long i = 0; i < n; ++i){
        for(long long j = 0; j <= i; ++j){
            for(long long k = 0; k <= i; ++k){
                long long tmp = table[i][j][k] - glasses[i][j][k];
                if(tmp < 0){
                    return 0;
                }
                table[i][j][k] = glasses[i][j][k];
                table[i+1][j][k] += tmp / 4 + ((tmp%4 > 0)?1:0);
                table[i+1][j][k+1] += tmp / 4 + ((tmp%4 > 1)?1:0);
                table[i+1][j+1][k+1] += tmp / 4 + ((tmp%4 > 2)?1:0);
                table[i+1][j+1][k] += tmp / 4;
            }
        }
    }

    return 1;
}