#include<fstream>
#include<iostream>
#include<string.h>
#include<vector>
#include<set>
#include<algorithm>

using namespace std;

vector<int> G[100010];

int LAZY[5 * 100010];
int current_root = 1;

int val[100010];

pair<int, int> segments[100010];
int nr = 0;

void update(int a, int b, int x, int y, int v, int k)
{
	if (x != y)
	{
		LAZY[k * 2] += LAZY[k];
		LAZY[k * 2 + 1] += LAZY[k];
	}
	else
	{
		val[x] += LAZY[k];
	}

	LAZY[k] = 0;

	if (a <= x && y <= b)
	{

		LAZY[k] += v;

		return;
	}
	int mid = (x + y) >> 1;
	if (a <= mid)
		update(a, b, x, mid, v, k * 2);

	if (b > mid)
		update(a, b, mid + 1, y, v, k * 2 + 1);


}

int query(int a, int x, int y, int k)
{
	if (x != y)
	{
		LAZY[k * 2] += LAZY[k];
		LAZY[k * 2 + 1] += LAZY[k];

		LAZY[k] = 0;
	}
	else
	{
		val[x] += LAZY[k];

		LAZY[k] = 0;

		return val[x];
	}



	int mid = (x + y) >> 1;

	if (a <= mid)
		return query(a, x, mid, k * 2);
	else
		return query(a, mid + 1, y, k * 2 + 1);
}

void DFS(int x, int f)
{
	++nr;
	segments[x].first = nr;
	for (int i = 0; i < G[x].size(); ++i)
	{
		if (G[x][i] != f)
		{
			DFS(G[x][i], x);
		}
	}
	segments[x].second = nr;
}

int main()
{
	int N, Q;

	cin >> N;



	for (int i = 1; i <= N - 1; ++i)
	{
		int x, y;

		cin >> x >> y;

		G[x].push_back(y);
		G[y].push_back(x);

	}

	DFS(1, 0);

	for(int i=1;i<=N;++i)
	{
		sort(G[i].begin(), G[i].end(), [&](int a,int b)
		{
			return segments[a].first < segments[b].first;
		});
	}

	cin >> Q;
	int op;
	for (int i = 1; i <= Q; ++i)
	{

		cin >> op;
		int x, v;
		if (op == 1)
		{

			cin >> x >> v;
			if (segments[x].first <= segments[current_root].first && segments[current_root].first <= segments[x].second)
			{
				update(1, N, 1, N, v, 1);

				if (x != current_root)
				{

					auto child_node = upper_bound(G[x].begin(), G[x].end(), current_root, [&](int a, int b)
					{
						return segments[a].first < segments[b].first;
					});

					child_node--;

					update(segments[*child_node].first, segments[*child_node].second, 1, N, -v, 1);
				}
			}
			else
				update(segments[x].first, segments[x].second, 1, N, v, 1);
		}
		else if (op == 2)
		{
			cin >> x;

			cout << query(segments[x].first, 1, N, 1) << "\n";

		}
		else
		{
			cin >> x;

			current_root = x;

		}


	}

	return 0;
}