// O(N*M^3) worst case
#include <stdio.h>
#include <string.h>

#define NMax 10005
#define PMax 1005

char S[NMax], P[PMax];
int N, M, K;

// number of matches of P in S ignoring [x, y] positions in P
int matches(int x, int y) { // O(N * M) worst case
	int matches = 0;
	for (int i = 0; i <= N - M; i++) {
		int match = 1;
		for (int j = 0; j < M; j++) {
			if (P[j] == S[i+j] ||
				(x <= j && j <= y)) {
				// match, do nothing
			} else {
				match = 0;
				break;
			}
		}
		matches += match;
	}
	return matches;
}

int main() {
	scanf("%s\n%s\n%d", &S, &P, &K);
	N = strlen(S);
	M = strlen(P);

	// O(M^2) matches() calls
	if (matches(0, -1) >= K) {
		// no change needed
		printf("0\n");
	} else {
		int min = M;
		for (int i = 0; i < M; i++) {
			for (int j = i; j < M; j++) {
				if (matches(i, j) >= K &&
					min > j-i+1) {
					min = j-i+1;
				}
			}
		}
		printf("%d\n", min);
	}

	return 0;
}
