// O(N*M^2)
#include <stdio.h>
#include <string.h>

#define NMax 10005
#define PMax 1005

char S[NMax], P[PMax];
int N, M, K;

int pre[NMax], suf[NMax];
// pre[i] = matching prefix of S[i..] with P[0..]
// suf[i] = matching  sufix of S[..j] with P[..M], j = i+M, M = |P|-1

// number of matches of P in S ignoring [x, y] positions in P
int matches(int x, int y) { // O(N)
	int matches = 0;
	for (int i = 0; i <= N - M; i++) {
		if (pre[i] >= x &&
			suf[i] >= M-1-y) {
			matches++;
		}
	}
	return matches;
}

int main() {
	scanf("%s\n%s\n%d", &S, &P, &K);
	N = strlen(S);
	M = strlen(P);

	// O(N x M)
	int perfect = 0;
	for (int i = 0; i <= N - M; i++) { // any possible match position
		for (pre[i] = 1; pre[i] <= M && P[pre[i]-1] == S[i + pre[i]-1]; pre[i]++);
		pre[i]--;
		for (suf[i] = 1; suf[i] <= M && P[M-suf[i]] == S[i + M-suf[i]]; suf[i]++);
		suf[i]--;
		if (pre[i] == M) {
			perfect++;
		}
	}

	// O(M^2) matches() calls
	if (perfect >= K) {
		// no change needed
		printf("0\n");
	} else {
		int min = M;
		for (int i = 0; i < M; i++) {
			for (int j = i; j < M; j++) {
				if (matches(i, j) >= K &&
					min > j-i+1) {
					min = j-i+1;
				}
			}
		}
		printf("%d\n", min);
	}

	return 0;
}
