// O(N*M)
#include <stdio.h>
#include <string.h>

#define NMax 10005
#define PMax 1005

char S[NMax], P[PMax];
int N, M, K;

int pre[NMax], suf[NMax];
// pre[i] = matching prefix of S[i..] with P[0..]
// suf[i] = matching  sufix of S[..j] with P[..M], j = i+M, M = |P|-1

int freqPS[PMax][PMax];
// freqPS[x][y] = how many positions i have pre[i] = x and suf[i] = y
int freqPSP[PMax];
// freqPSP[y] = how many positions i have pre[i] >= (curren Prefix iterator) and suf[i] = y

int main() {
	scanf("%s\n%s\n%d", &S, &P, &K);
	N = strlen(S);
	M = strlen(P);

	// O(N x M)
	for (int i = 0; i <= N - M; i++) { // any possible match position
		for (pre[i] = 1; pre[i] <= M && P[pre[i]-1] == S[i + pre[i]-1]; pre[i]++);
		pre[i]--;
		for (suf[i] = 1; suf[i] <= M && P[M-suf[i]] == S[i + M-suf[i]]; suf[i]++);
		suf[i]--;

		freqPS[pre[i]][suf[i]]++; // count how many (pre, suf) pairs we have
	}

	if (freqPS[M][M] >= K) {
		printf("0\n");
	} else {

		for (int i = 0; i < M; i++) {
			for (int j = 0; j <= M; j++) {				
				freqPSP[j] += freqPS[i][j];
				// sum of each column
			}
		}
		int min = M;
		for (int i = 0; i < M; i++) {
			int matches = 0;
			for (int j = i; j < M; j++) {
				// put '?' on positions from i to j in P
				matches += freqPSP[M-j-1];
				if (matches >= K && min > j-i+1) {
					min = j-i+1;
				}
			}
			for (int j = 0; j < M; j++) {
				freqPSP[j] -= freqPS[i][j];
			}
		}

		printf("%d\n", min);

	}

	return 0;
}
