// O(N*M)
#include <stdio.h>
#include <string.h>

#define NMax 10005
#define PMax 1005

char S[NMax], P[PMax];
int N, M, K;

int pre[NMax], suf[NMax];
// pre[i] = matching prefix of S[i..] with P[0..]
// suf[i] = matching  sufix of S[..j] with P[..M], j = i+M, M = |P|-1

int freqPS[PMax][PMax];
// freqPS[x][y] = how many positions i have pre[i] = x and suf[i] = y

int main() {
	scanf("%s\n%s\n%d", &S, &P, &K);
	N = strlen(S);
	M = strlen(P);

	// O(N x M)
	for (int i = 0; i <= N - M; i++) { // any possible match position
		for (pre[i] = 1; pre[i] <= M && P[pre[i]-1] == S[i + pre[i]-1]; pre[i]++);
		pre[i]--;
		for (suf[i] = 1; suf[i] <= M && P[M-suf[i]] == S[i + M-suf[i]]; suf[i]++);
		suf[i]--;

		freqPS[pre[i]][suf[i]]++; // count how many (pre, suf) pairs we have
	}

	if (freqPS[M][M] >= K) {
		printf("0\n");
	} else {

		for (int j = M; j >= 0; j--) {
			for (int i = M; i >= 0; i--) {
				freqPS[i][j] += freqPS[i][j+1] + freqPS[i+1][j] - freqPS[i+1][j+1]; // :( this is PD
				// freqPS[i][j] = how many positions have prefixes >= i and sufixes >= j
			}
		}
		int min = M;
		for (int i = 0; i < M; i++) {
			for (int j = i; j < M; j++) {
				// put '?' on positions from i to j in P
				if (freqPS[i][M-j-1] >= K && min > j-i+1) {
					min = j-i+1;
				}
			}
		}

		printf("%d\n", min);

	}

	/*
	// O(M x M)
	int lg = 1;
	int matches = freqPS[M][M];
	// how many matches we had with shorter operations, first with perfect operations
	
	for (; ; lg++) {
		if (matches >= K) {
			break;
		}
		// add how many matches we get with exactly lg number of '?'
		for (int i = 0; i < M - lg + 1; i++) {
			// first i match:       positions [0,      i-1]
			// next lg don't match: positions [i,   i+lg-1]
			// last M-(i+lg) match: positions [i+lg,   M-1]
			matches += freqPS[i][M-(i+lg)];
		}
	}
	printf("%d\n", lg);
	*/

return 0;
}
